import logging

import grpc
from oauthlib.oauth2 import BackendApplicationClient

from perxis.auth import OAuth2Plugin
from perxis.collections_perxis.collections_pb2 import ListRequest
from perxis.collections_perxis.collections_pb2_grpc import CollectionsStub


def main():
    client_id = 'YGPQSAUPgco4iTQxNejtXDjFVwPmYT3n'
    client_secret = '_d6F-VlQGmcsU25AXIoCU4EU3v56-28P6jwUHkutg_hSPseConphyLs3F-Buuq1h'
    token_url = 'https://adwz.auth0.com/oauth/token'
    audience = 'some'

    oauth2_plugin = OAuth2Plugin(
        client=BackendApplicationClient(client_id=client_id),
        client_secret=client_secret,
        token_url=token_url,
        audience=audience
    )

    call_credentials = grpc.metadata_call_credentials(oauth2_plugin, name='auth')
    channel_credentials = grpc.ssl_channel_credentials()
    composite_credentials = grpc.composite_channel_credentials(
            channel_credentials, call_credentials
    )
    with grpc.secure_channel('envoy.perxis.pt.perx.ru:443', composite_credentials) as channel:
        stub = CollectionsStub(channel)
        collections = stub.List(ListRequest(space_id="c1mrvup3e6litup7tf0g", env_id="master"))
        print(collections)


if __name__ == '__main__':
    logging.basicConfig(level=logging.INFO)
    main()
